#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import cvxpy as cp
import math as mp

w = cp.Variable(pos=True)
h = cp.Variable(pos=True)
d = cp.Variable(pos=True)

phi = (1+mp.sqrt(5))/2.0
constraints = [
  w*h + w*d + h*d <= 0.5, h <= (phi)*w, 1.5*w <= h]
problem = cp.Problem(cp.Maximize(w*h*d), constraints)
problem.solve(gp=True,verbose=True)
print("Optimal value: ", problem.value)
print("w: ", w.value)
print("h: ", h.value)
print("d: ", d.value)
