#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import cvxpy as cp
import numpy as np
import matplotlib.pyplot as plt

np.random.seed(1)
m = 100
p = np.random.randn(m,2)

fig, ax = plt.subplots()
plt.xlim(-3,3)
plt.ylim(-3,3)
plt.plot(p[:,0],p[:,1], 'bo')
plt.axis('equal')

x = cp.Variable(3)
soc_constraints = [
      cp.SOC(x[2], p[i,:]-x[0:2]) for i in range(m)
]
prob = cp.Problem(cp.Minimize(x[2]),
                 soc_constraints)
prob.solve()

print("The optimal value is", prob.value)
print("A solution x is")
print(x.value)

ax.add_patch(plt.Circle(x.value[0:2], radius=x.value[2], fill=False))
plt.plot(x.value[0],x.value[1], 'ro')
plt.plot()