#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import cvxpy as cp
import numpy as np

#Build adjacency matrix
A = np.zeros([5,5])
A[0,1] = 1
A[0,2] = 1
A[1,2] = 1
A[1,3] = 1
A[2,4] = 1
A[3,4] = 1
A = A+A.T

X = cp.Variable((5,5), symmetric=True)
# X >> 0 indicates that X must be positive semidefinite
constraints = [X >> 0]
constraints += [
    X[i,i] == 1 for i in range(5)
]
prob = cp.Problem(cp.Maximize(cp.trace(-A/4 @ X)),
                  constraints)
prob.solve()

print("The optimal value is", prob.value)
print("Optimal X")
print(X.value)
sdp_opt = prob.value+np.trace(np.dot(A/4,np.ones([5,5])))
print("SDP relaxation value:", sdp_opt)
print("Relaxation ration: ", 5.0/sdp_opt)

print("Dual slack S:", constraints[0].dual_value)
print("tr(XS):", np.trace(np.dot(constraints[0].dual_value,X.value)))
